$ontext
 this files solves a jobshop scheduling problem with zero wait
example 2 from paper submitted to aiche annual meeting, miami
this problem has 5 jobs and 5 stages #2
References: Raman & Grossmann, Comp. & Chem. Eng., 18, 7, p.563-578, 1994.
This is a COMPACT DISJUNCTION formularion where the domain of the
disjunctions are limitted using the WITH clause, the subset L(I,J,K) and
GAMS GDX facilities
$offtext

SETS  I  jobs  / A, B, C, D, E /;
ALIAS (I,K)   ;
SET J  stages    / 1*5 / ;
ALIAS (J,M)   ;

SET L(I,K,J) /A.B.1, A.B.2, A.B.3, A.B.4, A.B.5,
         A.C.1, A.C.2, A.C.3, A.C.4, A.C.5,
         A.D.1, A.D.2, A.D.3, A.D.4, A.D.5,
         A.E.1, A.E.2, A.E.3, A.E.4, A.E.5,
         B.C.1, B.C.2, B.C.3, B.C.4, B.C.5,
         B.D.1, B.D.2, B.D.3, B.D.4, B.D.5,
         B.E.1, B.E.2, B.E.3, B.E.4, B.E.5,
         C.D.1, C.D.2, C.D.3, C.D.4, C.D.5,
         C.E.1, C.E.2, C.E.3, C.E.4, C.E.5,
         D.E.1, D.E.2, D.E.3, D.E.4, D.E.5/;

TABLE TAU(I,J) processing time of job i in stage j

             1       2       3       4       5
      A      2       6       5       7       3
      B      5       2       4       5       4
      C      4       8       2       8       3
      D      3       3       5       6       4
      E      5       4       3       5       5     ;


VARIABLES      MS      makespan                     ;


BINARY VARIABLES Y(I,K,J) sequencing variable between jobs i and k;
POSITIVE VARIABLES T(I) ;


EQUATIONS
           FEAS(I)           makespan greater than all processing times
           NOCLASH1(I,K,J)   when i precedes k
           NOCLASH2(I,K,J)   when k precedes i
           DUMMY     ;



FEAS(I).. MS =G= T(I) + SUM(J,TAU(I,J))  ;


NOCLASH1(I,K,J)$((ORD(I) LT ORD(K)) AND L(I,K,J)) ..

T(I) + SUM(M$(ORD(M) LE ORD(J)), TAU(I,M)) =L=
          T(K) + SUM(M$(ORD(M) LT ORD(J)), TAU(K,M)) ;


NOCLASH2(I,K,J)$((ORD(I) LT ORD(K)) AND L(I,K,J)) ..

T(K) + SUM(M$(ORD(M) LE ORD(J)),TAU(K,M)) =L=
          T(I) + SUM(M$(ORD(M) LT ORD(J)), TAU(I,M)) ;

DUMMY.. SUM(I, SUM(K, SUM(J, Y(I,K,J)))) =G= 0;

T.up(k)=1000;
MODEL JOBSHOP / ALL / ;


OPTION MIP      = LMBigm;
OPTION WORK     = 5000000 ;
OPTION ITERLIM  = 500000 ;
OPTION RESLIM   = 4000 ;
OPTION OPTCR    = 0.0 ;
OPTION OPTCA    = 0.0 ;
OPTION LIMROW   = 90 ;
OPTION LIMCOL   = 0 ;

$ONECHO > "%lm.info%"

DISJUNCTION D1(I,K,J);

D1(I,K,J)
        with ((ord(I) < ord(K)) and L(I,K,J)) IS
IF Y(I,K,J) THEN
        NOCLASH1(I,K,J);
ELSE
        NOCLASH2(I,K,J);
ENDIF;


$offecho

SOLVE JOBSHOP MINIMIZING MS USING MIP ;
