$Title LogMip User's Manual Small Example 1
* This is a small demonstrative example 1 - version 3
* This corresponds to a very compact formulation of the same problem
* proposed by Alex Meeraus

* Three jobs (A,B,C) must be executed sequentially in three steps, but
* not all jobs require all the stages. The objective is to obtain the
* sequence of tasks which minimizes the completion time. Once a job has
* started it cannot be interrupted.
*
* The objective is to obtain the sequence of task, which minimizes the
* completion time.
*
* Ref: Raman & Grossmann, Comp. & Chem. Eng., 18, 7, p.563-578, 1994.


sets j jobs   / A, B, C /
     s stages / 1*3 /


alias (j,jj),(s,ss);

table p(j,s) processing time

     1   2   3
  A  5       3
  B      3   2
  C  2   4

parameter c(j,s)  stage completion time
          w(j,jj) maximum pairwise waiting time
          pt(j)   total processing time
          big     the famous big M;
set     gg(j,jj) upper triangle
        dif(j,jj);
gg(j,jj) = ord(j) < ord(jj);
dif(j,jj)= ord(j) <> ord(jj);

c(j,s)  = sum(ss$(ord(ss)<=ord(s)), p(j,ss));
w(j,jj) = smax(s, c(j,s) - c(jj,s-1));
pt(j)   = sum(s, p(j,s));
big     = sum(j, pt(j));

variables t       completion time
          x(j)    job starting time
          y(j,jj) job precedence

positive variable x; binary variable y;

equations comp(j)   job completion time
          seq(j,jj) job sequencing j beore jj
          dummy     force names into model;


comp(j).. t =g= x(j) + pt(j);

*seq(j,jj)$(not sameas(j,jj))..  x(j) + w(j,jj) =l= x(jj);
seq(j,jj)$dif(j,jj)..  x(j) + w(j,jj)**2 =l= x(jj);

dummy.. sum((j,jj)$gg(j,jj), y(j,jj)) =g= 0;

x.up(j) = big;

model m / all /;

$ONECHO > "%lm.info%"
Disjunction d(j,jj);

d(j,jj) with gg(j,jj) is
if y(j,jj)
   then seq(j,jj);
   else seq(jj,j);
endif;


$offecho
option mip=lmchull;

solve m using MIP minimizing t;
