* This problem corresponds to the optimal solution of
* a problem fitting a set of rectangles of fixed dimensions
* in a strip with fixed width W and variable length L that
* is to be minimized
* Reference: Sawaya, N.S.. and Grossmann I.E.,
*        "A cutting plane method for solving
*        linear generalized disjunctive programming problems".
*        Proceedings of PSE2003, 1032 (2003).
* No rotation of the rectangles is assumed
* In this case we have the dimensions of 4 rectangles.
*
* This is the same problem than cortes_1
* but THIS CASE CORRESPONDS TO  A COMPACT DISJUNCTION FORMULATION
* using WITH clause
*
SET I number of boxes /1*4/;
SET K number of disjunctions terms /1*4/;
ALIAS (I,J);
SCALAR W /10/;
PARAMETER H(I) /1 6, 2 3, 3 4, 4 2/;
PARAMETER L(I) /1 6, 2 8, 3 5, 4 3/;
BINARY VARIABLES Y(I,J,K);
POSITIVE VARIABLES X(I),HE(I), LONG;
VARIABLE Z;
EQUATIONS EQUAT1(I),  EQUAT2(I,J), EQUAT3(I,J), EQUAT4(I,J),
          EQUAT5(I,J), DUMMY, OBJECTIVE;

EQUAT1(I).. LONG =G= X(I)+ L(I);
EQUAT2(I,J)$(ord(i) < ord(j)).. X(I)+L(I)=L=X(J);
EQUAT3(I,J)$(ord(i) < ord(j)).. X(J)+L(J)=L=X(I);
EQUAT4(I,J)$(ord(i) < ord(j)).. HE(I)-H(I)=G=HE(J);
EQUAT5(I,J)$(ord(i) < ord(j)).. HE(J)-H(J)=G=HE(I);

DUMMY.. SUM(I,sum(j,sum(k$(ord(i) < ord(j)), Y(I,J,K)))) =G= 0;

X.UP(I)=30.;
HE.UP(I)=W;
HE.LO(I)=H(I);

OBJECTIVE.. Z =E= LONG;
$ONECHO > "%lm.info%"
DISJUNCTION D(I,J);

D(I,J) with (ord(I) < ord(J)) is
IF Y(I,J,'1') THEN
        EQUAT2(I,J);
ELSIF Y(I,J,'2') THEN
        EQUAT3(I,J);
ELSIF Y(I,J,'3') THEN
        EQUAT4(I,J);
ELSIF Y(I,J,'4') THEN
        EQUAT5(I,j);
ENDIF;

$offecho

OPTION LIMCOL=0;
OPTION LIMROW=0;
OPTION MIP=LMBIGM;
MODEL PEQUE1 /ALL/;
SOLVE PEQUE1 USING MIP MINIMIZING Z;